'Instructions:

'Place these on the server (lower case)
'   myapp.new --> myapp.exe renamed to myapp.new
'   myapp.ver --> version number of myapp.new, such as 1.0

'Add these lines of code to the main application:
'   #Include "gbonlineupdate.inc"
'   #Resource Icon, aaa, "images\download.ico"   'user-supplied icon, representing the main EXE. must be 48x48.
'   If RestartUpdate Then RestartUpdatedEXE
'   hUpdateParent = hDlg      'where hDlg is the handle to the parent o
'   CheckForEXEUpdates($ver)

'Edit these variables in the code below:
'     URLSite = "www.garybeene.com"                                                 'server
'     URLVerPath = "http://www.garybeene.com/files/" + LCase$(Exe.Name$) + ".ver"   'gives version number on server (myapp.ver)
'     URLFilePath = "http://www.garybeene.com/files/" + LCase$(Exe.Name$) + ".new"  'is the latest EXE (named myapp.new)

#Include "WinINET.inc"

%IDUP_DownloadLabel    = 7000
%IDUP_ProgressBar      = 7001
%IDUP_InstallOk        = 7002
%IDUP_InstallCancel    = 7003
%IDUP_InstallCheckBox  = 7004
%IDUP_InstallImage     = 7005
%IDUP_InstallLabel     = 7006

Global gUpdateHook   As Dword
Global hUpdateWait   As Dword
Global hUpdateParent As Dword
Global RestartUpdate As Dword

Sub RestartUpdatedEXE
   Local iResult As Long
   If IsFile(Exe.Path$ + Exe.Name$ + ".exe.old") Then Kill Exe.Path$ + Exe.Name$ + ".exe.old"
   Name Exe.Path$ + Exe.Name$ + ".exe" As Exe.Path$ + Exe.Name$ + ".exe.old"
   Name Exe.Path$ + Exe.Name$ + ".new" As Exe.Path$ + Exe.Name$ + ".exe"
   iResult = Shell(Exe.Full$,1)
End Sub

Sub CheckForEXEUpdates(CurrentVer$)
   'Ver 2.0 (CheckforUpdates function only)

   'CheckForUpdates function does these things
   '    --> downloads myapp.ver, compares it to local app version
   '    --> if user agrees, kill myapp.new then download myapp.new (please wait dialog w/progress bar appears)
   '    --> get appname, position, location from commandline
   '    --> Kill myapp.exe.old
   '   ---> renames myapp.exe as myapp.exe.old
   '   ---> renames myapp.new as myapp.exe
   '   ---> restart myapp.exe (which is the new version)

   Local LocalFilePath, URLSite, URLVerPath, URLFilePath, ServerVer As WStringZ * %Max_Path
   Local w,h,ServerFileSize As Long, Style As Long, Buffer, AllBytes As String
   Local locX As Long, locY As Long, sizeX As Long, sizeY As Long
   'local information
   LocalFilePath = Exe.Path$ + Exe.Name$ + ".new"   'location to put downloaded new EXE (renamed as NEW) file on local PC

   'server information
   URLSite = "www.garybeene.com"                                                 'server
   URLVerPath = "http://www.garybeene.com/files/" + LCase$(Exe.Name$) + ".ver"   'gives version number on server (myapp.ver)
   URLFilePath = "http://www.garybeene.com/files/" + LCase$(Exe.Name$) + ".new"  'is the latest EXE (named myapp.new)

   'clear the cache for the .new file
   DeleteURLCacheEntry(LocalFilePath)  '1 = success  clear the cache

   'read the .ver file from the server (not save, just read content into buffer)
   'if cannot get it tell user there was a problem and then exit Sub
   Tcp Open "HTTP" At URLSite As #1 TimeOut 60000
   Tcp Print #1, "GET  " + URLVerPath + "  HTTP/1.0"
   Tcp Print #1, ""
   Tcp Print #1, ""
   Tcp Recv #1, 4096, ServerVer    'this gets the Header + Body
'? "bytes received: " + Str$(Len(ServerVer))
'   Tcp Recv #1, 4096, ServerVer    'this gets the Header + Body
'? "bytes received: " + Str$(Len(ServerVer))
   Tcp Close #1
   ServerVer = Remain$(ServerVer, $CrLf + $CrLf)   'this returns just the body

   'if ServerVer not newer than local version, tell user and then exit Sub
   Select Case Val(ServerVer)
      Case 0
         gUpdateHook = SetWindowsHookEx(%WH_CBT, CodePtr(Update_MsgProc), GetModuleHandle(""), GetCurrentThreadId)
         MessageBox  0, "Update information not available!", "Online Update", %MB_TaskModal Or %MB_Ok Or %MB_IconExclamation
         Exit Sub
      Case <= Val(CurrentVer$)
         gUpdateHook = SetWindowsHookEx(%WH_CBT, CodePtr(Update_MsgProc), GetModuleHandle(""), GetCurrentThreadId)
         MessageBox 0, "You have the latest update!", "Online Update", %MB_TaskModal Or %MB_Ok Or %MB_IconInformation
         Exit Sub
   End Select

   'server version is now verified as newer than local version
   'ask user for permission to proceed with download
   Style = %MB_OkCancel Or %MB_IconQuestion Or %MB_TaskModal
   gUpdateHook = SetWindowsHookEx(%WH_CBT, CodePtr(Update_MsgProc), GetModuleHandle(""), GetCurrentThreadId)
   If MessageBox (0, "Update available. Download and install?", "Online Update", Style) = %IdCancel Then Exit Sub

   'before downloading, remove the existing .old and .new files, if they exist
   If IsFile(LocalFilePath) Then Kill LocalFilePath           'kill .new to clear the way

   'Get file size to use in download display status
    Tcp Open "HTTP" At URLSite As #1 TimeOut 60000
    Tcp Print #1, "HEAD  " + URLFilePath + "  HTTP/1.0"
    Tcp Print #1, "" : Tcp Print #1, ""
    Tcp Recv #1, 4096, Buffer : Tcp Close #1
    Buffer = Remain$(Buffer, "Content-Length:")
    ServerFileSize = Val(Extract$(Buffer, $CrLf))

    'Exit Sub if filesize is zero (tell user of the problem)
    If ServerFileSize = 0 Then
       gUpdateHook = SetWindowsHookEx(%WH_CBT, CodePtr(Update_MsgProc), GetModuleHandle(""), GetCurrentThreadId)
       MessageBox 0, "Download file Not found!", "Online Update", %MB_TaskModal Or %MB_Ok + %MB_IconExclamation
       Exit Sub
    End If

   'Display a Downloading ... PleaseWait dialog with a download status progress bar
   Dialog Get Client hUpdateParent To w,h
   sizeX = 170 : sizeY = 90
   locX = (w-sizeX)/2    'gets left position of WaitDialog to center over app
   locY = (h-sizeY)/2    'gets top position of WaitDialog to center over app
   Dialog New Pixels, hUpdateParent, "", locX, locY, sizeX, sizeY, %WS_Popup To hUpdateWait
   Control Add Label, hUpdateWait, %IDUP_DownloadLabel, $CrLf + "Downloading ... please wait !", 0, 0, sizeX, sizeY, %SS_Center Or %WS_Border
   Control Set Color hUpdateWait, %IDUP_DownloadLabel, %Black, %White
   Control Add Progressbar, hUpdateWait, %IDUP_ProgressBar,"", 10,sizeY-40,sizeX-20,20   'bottom of dialog, but on top of label
   Dialog Show Modeless hUpdateWait  'no dlg proc required

   'Download the file
   Tcp Open "http" At URLSite As #1 TimeOut 60000   'connect
   If Err Then Beep : Exit Sub
   Tcp Print #1, "GET " & URLFilePath & " HTTP/1.0"      'send the GET request
   Tcp Print #1, ""
   Do                                                              'get bytes until no more available
     Tcp Recv #1, 4096, Buffer
     AllBytes = AllBytes + Buffer
     Progressbar Set Pos hUpdateWait, %IDUP_ProgressBar, (100*Len(AllBytes)/ServerFileSize)
   Loop While IsTrue Len(Buffer) And IsFalse Err
   Tcp Close #1                     'done, close the connection
   Dialog End hUpdateWait                'Remove the download status dialog

   If Len(AllBytes) = 0 Then
      'download failed. tell the user then exit sub
      gUpdateHook = SetWindowsHookEx(%WH_CBT, CodePtr(Update_MsgProc), GetModuleHandle(""), GetCurrentThreadId)
      MessageBox 0, "Download of updated version failed!", "Online Update", %MB_TaskModal Or %MB_Ok Or %MB_IconExclamation
      Exit Sub
   End If

   'Save the file, but first take off the HTTP header from the received bytes
   AllBytes  = Remain$(AllBytes, $CrLf + $CrLf)
   Open LocalFilePath For Binary As #1
   Put$ #1,AllBytes
   Close #1

   'the new application was successfully downloaded. ask user for permission to proceed
   gUpdateHook = SetWindowsHookEx(%WH_CBT, CodePtr(Update_MsgProc), GetModuleHandle(""), GetCurrentThreadId)
   If MessageBox(0, "Download complete. Install and restart?", "Online Update", %MB_TaskModal Or %MB_OkCancel Or %MB_IconExclamation) = %IdCancel Then Exit Sub
   RestartUpdate = 1
   Dialog End hUpdateParent
End Sub

Function Update_MsgProc(ByVal lMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x,y,w,h,CenterX,CenterY As Long    'MsgBox is approximately 200x200
   Dialog Get Loc hUpdateParent To x,y
   Dialog Get Size hUpdateParent To w,h
   CenterX = x + (w-200)/2
   CenterY = y + (h-200)/2
   If lMsg = %HCBT_ACTIVATE Then
      SetWindowPos wParam, 0, x,y, 0, 0, %SWP_NOSIZE Or %SWP_NOACTIVATE Or %SWP_NOZORDER
      UnhookWindowsHookEx gUpdateHook
   End If
End Function
