'Compilable Example:
#Compiler PBWin 10
#Compile Exe   "gbasteroids.exe"
#Dim All
%Unicode = 1
#Include "Win32API.inc"
#Include "cgdiplus.inc"
#Include "files\gbOnlineUpdate.inc"

#Resource Icon logo, "images\gbasteroid.ico"
#Resource Icon xnew "images\new.ico"
#Resource Icon xsettings "images\settings.ico"
#Resource Icon xhelp "images\help.ico"
#Resource Icon xsoundb "images\soundblock.ico"
#Resource Icon xexit "images\exit.ico"
#Resource Icon xcenter "images\center.ico"
#Resource Icon xpause "images\pause.ico"
#Resource Icon xplay "images\play.ico"


#Resource RcData, xship32, "images\ship32.ico",       '0
#Resource RcData, xship32b, "images\ship32b.ico",     '1
#Resource RcData, xasteroid, "images\gbasteroid.ico", '2
#Resource RcData, xphaser, "images\phaser.ico",       '3
#Resource RcData, xdead, "images\dead.ico",           '4
#Resource RcData, xdeadship, "images\deadship.ico"    '11
#Resource RcData, xbackground, "images\background.jpg"    '5
#Resource RcData, xbackgroundb, "images\backgroundb.jpg" '6
#Resource RcData, xbackgroundc, "images\backgroundc.jpg" '7
#Resource RcData, xbackgroundd, "images\backgroundd.jpg" '8
#Resource RcData, xbackgrounde, "images\backgrounde.jpg" '9
#Resource RcData, xbackgroundf, "images\backgroundf.jpg" '10

#Resource Wave xphaser, "sounds\phaser.wav"
#Resource Wave xrocket, "sounds\rocket.wav"
#Resource Wave xexplode, "sounds\explode.wav"

$Ver = "1.03"
$SessionFile = "tempfiles\gbAsteroids.dat"

Type ImageTypeX
   w As Long
   h As Long
   hBMP As Dword
   hDC As Dword
End Type

Type SpriteType
   x As Single          'x position
   y As Single          'y position
   w As Long            'width
   h As Long            'height
   velx As Single       'x velocity
   vely As Single       'x velocity
   theta As Single      'current angle
   velTheta As Single   'spin rate
   active As Long       'empty or in use
   hBMP As Dword        'image handle
   hDC As Dword         'image DC
   r As Rect            'bounding rectangle
   type As Long         'type of sprite
   pt As Point          'point containing XY
End Type

Enum Equates Singular
   IDC_Button = 500
   IDC_Graphic
   IDC_Toolbar
   IDC_StatusBar
   ID_TimerMove
   ID_TimerPhaser

   IDM_Background
   IDM_Continuous
   IDM_ScrollBackground
   IDM_ShowShips
   IDM_SaveSession
   IDM_AutoRun
   IDM_Level1
   IDM_Level2
   IDM_Level3
   IDM_Escape
   IDM_OnlineUpdate
   IDM_Sep

   IDT_New
   IDT_Exit
   IDT_Play
   IDT_Pause
   IDT_Center
   IDT_Mute
   IDT_Settings
   IDT_Help

   Ship
   Asteroid
   Phaser
End Enum

Global hDlg,hDC,hSettings,hHelp,hBMPR,hDCR,hToolbar,hImageListTB,hFont,hGraphic As Dword
Global Sprites() As SpriteType, Images() As ImageTypeX, gmRect, ClientR As Rect
Global Interval, blastx, blasty, Volume, gM, Mute, Fire,ShipCount As Long
Global AutoRun,AsteroidCount,ContinuousPlay,ScrollBackground,ShowShips,SaveSession As Long
Global FPS, MaxPhaser, Blast, OldProc, Background, PlayGame,GameLevel,GameScore,MaxGameScore As Long
Global qFreq, qStart, qStop As Quad

Function PBMain() As Long
   Dialog New Pixels, 0, "gbAsteroids  v" + $ver,300,300,400,400, %WS_OverlappedWindow To hDlg
   Dialog Set Icon hDlg, "logo"
   CreateToolbar
   CreateStatusBar
   Control Add Graphic, hDlg, %IDC_Graphic,"", 0,55,400,400, %SS_Notify
   Control Handle hDlg, %IDC_Graphic To hGraphic
   Graphic Attach hDlg, %IDC_Graphic, ReDraw
   Graphic Font "Tahoma", 36, 0
   Graphic Get DC To hDC
   Graphic Color %Black, %Black
   Graphic Clear
   Dialog Show Modal hDlg Call DlgProc

   If RestartUpdate Then RestartUpdatedEXE

End Function

CallBack Function DlgProc() As Long
   Local w,h As Long, rc As Rect, temp$, pt As Point
   Local PTT As TooltipText Ptr, NMTB As TBNotify Ptr

   Select Case Cb.Msg
      Case %WM_InitDialog
         QueryPerformanceFrequency qFreq
         CreateSubFolders
         hUpdateParent = hDlg
         Settings_INI "get"
         gMRect.nLeft = -gM : gMRect.nTop = -gM
         ResizeWindow
         BuildAcceleratorTable
         LoadImages    'ship, ship-blasting, asteroid
         Graphic Attach hDlg, %IDC_Graphic, ReDraw

         If IsFile($SessionFile) Then
            ReDim Sprites(300)
            LoadGameSession
         Else
            InitializeSprites
         End If

         If AutoRun Then
            PlayGame = 1
            SetTimer hDlg, %ID_TimerMove, Interval, 0
         Else
            PlayGame = 0
            MoveAndDisplaySprites
         End If

         FillStatusBar
         CreateFonts
         OldProc = SetWindowLong(GetDlgItem(hDlg, %IDC_Graphic), %GWL_WndProc, CodePtr(NewProc))  'subclass
         SetMenusAndToolbar
         Control Set Focus hDlg, %IDC_Graphic

      Case %WM_Timer
         Select Case Cb.Ctl
            Case %ID_TimerMove
               QueryPerformanceCounter   qStart
               DetectCollisions
               MoveAndDisplaySprites
               FillStatusBar
               QueryPerformanceCounter   qStop
               FPS = qFreq\(qStop-qStart)
               If (ShipCount=0) Or (AsteroidCount=0) Then
                  PlayGame = 0
                  KillTimer hDlg, %ID_TimerMove
                  SetMenusAndToolbar
                  EndGame
                  InitializeSprites    'ship, ship-blasting, asteroid
               End If
            Case %ID_TimerPhaser
               FirePhaser
               PlayWave "xphaser", "loop"
         End Select

      Case %WM_Destroy
         KillTimer hDlg, %ID_TimerMove
         SaveGameSession
         SetWindowLong GetDlgItem(hDlg, %IDC_Graphic), %GWL_WNDPROC, OldProc   'un-subclass
         Settings_INI "save"

      Case %WM_Size : ResizeWindow

'      Case %WM_SetCursor
'         GetCursorPos pt
'         ScreenToClient hDlg, pt
'         If ChildWindowFromPoint(hDlg,pt) = hGraphic Then Control Set Focus hDlg, %IDC_Graphic

      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDT_New
               GameScore = 0
               InitializeSprites    'ship, ship-blasting, asteroid
               FillStatusBar

            Case %IDT_PLay
               PlayGame = 1
               FillStatusBar
               SetTimer hDlg, %ID_TimerMove, Interval, 0

            Case %IDT_Pause
               PlayGame = 0
               KillTimer hDlg, %ID_TimerMove

            Case %IDT_Center
               CenterShip

            Case %IDT_Exit
               Dialog End hDlg

            Case %IDT_Mute
               Mute Xor= 1
               SetMenusAndToolbar

            Case %IDT_Help
               'pause
               PlayGame = 0
               KillTimer hDlg, %ID_TimerMove
               'display Help
               DisplayHelp
               SetMenusAndToolbar
               'temp$ = "http://www.garybeene.com/sw/gbasteroids.htm"
               'w = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)

            Case %IDM_Escape
               PlayGame Xor= 1
               If PlayGame Then
                  SetTimer hDlg, %ID_TimerMove, Interval, 0
               Else
                  KillTimer hDlg, %ID_TimerMove
               End If

            Case %IDT_Settings, %IDM_Background
               BackGround +=1
               If Background > 10 Then Background = 5

            Case %IDM_Continuous
               ContinuousPlay Xor= 1
               SetMenusAndToolbar
               FillStatusBar

            Case %IDM_ScrollBackground
               ScrollBackground Xor= 1
               SetMenusAndToolbar

            Case %IDM_ShowShips
               ShowShips Xor= 1
               SetMenusAndToolbar

            Case %IDM_SaveSession
               SaveSession Xor= 1
               SetMenusAndToolbar

            Case %IDM_AutoRun
               AutoRun Xor=1
               SetMenusAndToolbar

            Case %IDM_Level1 : GameLevel = 1 : SetMenusAndToolbar : InitializeSprites : FillStatusBar
            Case %IDM_Level2 : GameLevel = 2 : SetMenusAndToolbar : InitializeSprites : FillStatusBar
            Case %IDM_Level3 : GameLevel = 3 : SetMenusAndToolbar : InitializeSprites : FillStatusBar

            Case %IDM_OnlineUpdate : CheckForEXEUpdates($ver)
         End Select

      Case %WM_Notify
         Select Case Cb.NmId
            Case %IDT_New To %IDT_Help
               Select Case Cb.NmCode
                  Case %TTN_GetDispInfo
                     PTT = Cb.LParam
                     @PTT.@lpszText = SetToolTips(Cb.NmId)
               End Select

            Case %IDC_Toolbar
               Select Case Cb.NmCode
                  Case %TBN_DROPDOWN
                     nmtb = Cb.LParam
                     Select Case @nmtb.iItem
                        Case %IDT_Settings
                           SendMessage(hToolbar, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                           MapWindowPoints(hToolbar, %HWND_Desktop, ByVal VarPtr(rc), 2)
                           Call TrackPopupMenu (hSettings, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                        Case %IDT_Help
                           SendMessage(hToolbar, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                           MapWindowPoints(hToolbar, %HWND_Desktop, ByVal VarPtr(rc), 2)
                           Call TrackPopupMenu (hHelp, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                     End Select
               End Select
         End Select

   End Select
End Function

Sub ResizeWindow
   Local w,h As Long
   Dialog Get Client hDlg To w,h
   Control Set Size hDlg, %IDC_Graphic, w,h-80
   gmRect.nRight = w+gm : gmRect.nBottom = h+gm+75
   ClientR.nLeft = 0
   ClientR.nTop = 0
   ClientR.nRight = w
   ClientR.nBottom = h - 75
End Sub

Sub LoadImageToMemoryBitmap (ImgName As String, hWin As Dword, hDCI As Dword, w As Long, h As Long)
   Local pGraphics,pImage,token As Dword, StartupInput As GdiplusStartupInput
   'initialize GDI
   StartupInput.GdiplusVersion = 1                    'initialize GDIPlus
   GdiplusStartup(token, StartupInput, ByVal %NULL)   'initialize GDIPlus

   GdipLoadImageFromFile((ImgName), pImage)           'load image
   GdipGetImageWidth(pImage,w)                        'get width
   GdipGetImageHeight(pImage, h)                      'get height

   Graphic Bitmap New w,h To hWin
   Graphic Attach hWin, 0
   Graphic Get DC To hDCI

   GdipCreateFromHDC(hDCI, pGraphics)                  ' Create the Graphic object
   GdipDrawImage(pGraphics, pImage, 0, 0)             ' Draw the image

   'shutdown GDI
   If pImage Then GdipDisposeImage(pImage)            'cleanup
   If pGraphics Then GdipDeleteGraphics(pGraphics)    'cleanup
   GdiplusShutdown token                              'shutdown GDI+
End Sub

Sub ExtractResource(resName$,fName$)
   Local temp$
   temp$ = Resource$(RcData,resName$)
   Open fName$ For Binary As #1
   Put #1, , Abs temp$
   Close #1
End Sub

Sub LoadImages
   ReDim Images(11)       '0=ship  1=asteroid  3=phaser  4=background  5=dead

   If IsFalse(IsFile("images\ship32.ico")) Then ExtractResource("xship32", "images\ship32.ico")
   If IsFalse(IsFile("images\ship32b.ico")) Then ExtractResource("xship32b", "images\ship32b.ico")
   If IsFalse(IsFile("images\gbasteroid.ico")) Then ExtractResource("xasteroid", "images\gbasteroid.ico")
   If IsFalse(IsFile("images\phaser.ico")) Then ExtractResource("xphaser", "images\phaser.ico")
   If IsFalse(IsFile("images\dead.ico")) Then ExtractResource("xdead", "images\dead.ico")
   If IsFalse(IsFile("images\background.jpg")) Then ExtractResource("xbackground", "images\background.jpg")
   If IsFalse(IsFile("images\backgroundb.jpg")) Then ExtractResource("xbackgroundb", "images\backgroundb.jpg")
   If IsFalse(IsFile("images\backgroundc.jpg")) Then ExtractResource("xbackgroundc", "images\backgroundc.jpg")
   If IsFalse(IsFile("images\backgroundd.jpg")) Then ExtractResource("xbackgroundd", "images\backgroundd.jpg")
   If IsFalse(IsFile("images\backgrounde.jpg")) Then ExtractResource("xbackgrounde", "images\backgrounde.jpg")
   If IsFalse(IsFile("images\backgroundf.jpg")) Then ExtractResource("xbackgroundf", "images\backgroundf.jpg")
   If IsFalse(IsFile("images\deadship.ico")) Then ExtractResource("xdeadship", "images\deadship.ico")

   'put images into memory bitmaps
   LoadImageToMemoryBitmap "images\ship32.ico",      Images(0).hBMP, Images(0).hDC, Images(0).w, Images(0).h
   LoadImageToMemoryBitmap "images\ship32b.ico",     Images(1).hBMP, Images(1).hDC, Images(1).w, Images(1).h
   LoadImageToMemoryBitmap "images\gbasteroid.ico",  Images(2).hBMP, Images(2).hDC, Images(2).w, Images(2).h
   LoadImageToMemoryBitmap "images\phaser.ico",      Images(3).hBMP, Images(3).hDC, Images(3).w, Images(3).h
   LoadImageToMemoryBitmap "images\dead.ico",        Images(4).hBMP, Images(4).hDC, Images(4).w, Images(4).h
   LoadImageToMemoryBitmap "images\background.jpg",  Images(5).hBMP, Images(5).hDC, Images(5).w, Images(5).h
   LoadImageToMemoryBitmap "images\backgroundb.jpg", Images(6).hBMP, Images(6).hDC, Images(6).w, Images(6).h
   LoadImageToMemoryBitmap "images\backgroundc.jpg", Images(7).hBMP, Images(7).hDC, Images(7).w, Images(7).h
   LoadImageToMemoryBitmap "images\backgroundd.jpg", Images(8).hBMP, Images(8).hDC, Images(8).w, Images(8).h
   LoadImageToMemoryBitmap "images\backgrounde.jpg", Images(9).hBMP, Images(9).hDC, Images(9).w, Images(9).h
   LoadImageToMemoryBitmap "images\backgroundf.jpg", Images(10).hBMP, Images(10).hDC, Images(10).w, Images(10).h
   LoadImageToMemoryBitmap "images\deadship.ico",    Images(11).hBMP, Images(11).hDC, Images(11).w, Images(11).h

   'create 70x70 intermedicate bitmap to hold rotated bitmaps
   Graphic Bitmap New 70,70 To hBMPR
   Graphic Attach hBMPR,0
   Graphic Color %Black, %Black
   Graphic Get DC To hDCR
End Sub

Sub InitializeSprites
   Local i As Long
   Randomize Timer
   ReDim Sprites(300)    '0=ship  1-20 = asteroids 21-300 = phasers

   'initialize ship sprite index=0
   ShipCount = 5
   Sprites(0).hBMP   = Images(0).hBMP
   Sprites(0).hDC    = Images(0).hDC
   Sprites(0).w      = Images(0).w
   Sprites(0).h      = Images(0).h
   NewShip

   'initialize asteroid sprites (index = 1 to 20)
   GameScore = 0
   AsteroidCount = IIf(GameLevel=1,10,25)
   For i = 1 To AsteroidCount : RandomizeSprite(i) : Next i
End Sub

Sub NewShip
   Local w,h As Long
   Control Get Client hDlg, %IDC_Graphic To w,h
   Sprites(0).x      = (w-Images(0).w)\2
   Sprites(0).y      = (h-Images(0).h)\2
   Sprites(0).pt.x   = Sprites(0).x
   Sprites(0).pt.y   = Sprites(0).y
   Sprites(0).r.nLeft = Sprites(0).x - Sprites(0).w\2
   Sprites(0).r.nTop  = Sprites(0).y - Sprites(0).h\2
   Sprites(0).r.nRight = Sprites(0).r.nLeft + Sprites(0).w
   Sprites(0).r.nBottom  = Sprites(0).r.nTop + Sprites(0).h
   Sprites(0).theta  = 3.14159
   Sprites(0).velX   = 0
   Sprites(0).velY   = 0
   Sprites(0).type   = %Ship
   Sprites(0).Active = 1
End Sub

Sub RandomizeSprite(i As Long)
   Local w,h As Long
   Static Dir As Long
   Incr Dir : If Dir > 4 Then Dir = 1  'quadrant to contain random asteriod
   Control Get Client hDlg, %IDC_Graphic To w,h
   Sprites(i).w = Images(2).w
   Sprites(i).h = Images(2).h
   Select Case Dir
      Case 1 'left
         Sprites(i).x = Rnd(-gM,-gM\2)
         Sprites(i).y = Rnd(1,h)
      Case 2 'top
         Sprites(i).x = Rnd(1,w)
         Sprites(i).y = Rnd(-gM,-gM\2)
      Case 3 'right
         Sprites(i).x = Rnd(w+gM\2,w+gM)
         Sprites(i).y = Rnd(1,h)
      Case 4 'bottom
         Sprites(i).x = Rnd(1,w)
         Sprites(i).y = Rnd(h+gM\2,h+gM)
   End Select

   Select Case GameLevel
      Case 1,2    'slower
         Sprites(i).velx = Rnd(-4,4) : If Sprites(i).velx = 0 Then Sprites(i).velx = 1
         Sprites(i).vely = Rnd(-4,4) : If Sprites(i).vely = 0 Then Sprites(i).vely = 1
      Case 3      'faster
         Sprites(i).velx = Rnd(-10,10) : If Sprites(i).velx = 0 Then Sprites(i).velx = 1
         Sprites(i).vely = Rnd(-10,10) : If Sprites(i).vely = 0 Then Sprites(i).vely = 1
   End Select

   Sprites(i).velTheta = 0.01 * Rnd(-5,5)
   Sprites(i).type = %Asteroid
   Sprites(i).active = 1
   Sprites(i).hBMP = Images(2).hBMP
   Sprites(i).hDC = Images(2).hDC
End Sub

Sub MoveAndDisplaySprites
   Local i,x,y,w,h As Long
   Graphic Get Client To w,h
   Graphic Clear

   ScrollBackgroundImage(1,0)

   'Move & Display All Sprites
   For i = 200 To 0 Step -1
      If Sprites(i).active = 0 Then Iterate For

      'calculate new x-y-theta positions
      Select Case i
         Case 0
            If Blast Then
               Sprites(i).velx -= BlastX
               Sprites(i).vely += BlastY
            End If
            Sprites(i).x += Sprites(i).velx
            Sprites(i).y += Sprites(i).vely
            If (Sprites(i).x<-50)  Then Sprites(i).x = w+50
            If (Sprites(i).x>w+50) Then Sprites(i).x = -50
            If (Sprites(i).y<-50)  Then Sprites(i).y = h+50
            If (Sprites(i).y>h+50) Then Sprites(i).y = -50
'            If (Sprites(i).x<-gM) Or (Sprites(i).x>w+gM) Or (Sprites(i).y<-gM) Or (Sprites(i).y>h+gM) Then CenterShip
         Case 1 To 20
            Sprites(i).x += Sprites(i).velx
            Sprites(i).y += Sprites(i).vely
            Sprites(i).theta += Sprites(i).velTheta
            If (Sprites(i).x<-gM) Or (Sprites(i).x>w+gM) Or (Sprites(i).y<-gM) Or (Sprites(i).y>h+gM) Then RandomizeSprite(i)
         Case 21 To 200
            'position changes, but not velocity/theta
            Sprites(i).x += Sprites(i).velx
            Sprites(i).y += Sprites(i).vely
            If (Sprites(i).x<-gM) Or (Sprites(i).x>w+gM) Or (Sprites(i).y<-gM) Or (Sprites(i).y>h+gM) Then Sprites(i).active = 0
      End Select

      'display sprite
      ShowSprite i

      'point containing XY
      Sprites(i).pt.x   = Sprites(i).x
      Sprites(i).pt.y   = Sprites(i).y
      'bounding rectangle
      Sprites(i).r.nLeft = Sprites(i).x
      Sprites(i).r.nTop  = Sprites(i).y
      Sprites(i).r.nRight = Sprites(i).x + Sprites(i).w
      Sprites(i).r.nBottom = Sprites(i).y + Sprites(i).h

      'Adjust rectangle (tighten around used areas) - Unused
      Select Case i
         Case 0
            InflateRect Sprites(i).r,-7,-7
         Case 1 To 20
            InflateRect Sprites(i).r,-7,-7
         Case Else : 'No action
      End Select
      'Graphic Box (Sprites(i).r.nLeft,Sprites(i).r.nTop)-(Sprites(i).r.nRight,Sprites(i).r.nBottom),,%Red

      'allow dying asteroids/ships (.active < 0) to live for a short time
      If Sprites(i).active < 0 Then
         Select Case i
            Case 0
               Incr Sprites(i).active

               If Sprites(i).active = 0 Then
                  Decr ShipCount
                  FillStatusBar
                  Sprites(i).hBMP   = Images(0).hBMP
                  Sprites(i).hDC    = Images(0).hDC
                  Sprites(i).w      = Images(0).w
                  Sprites(i).h      = Images(0).h
                  NewShip
               End If

            Case 1 To 20
               Incr Sprites(i).active
               If ContinuousPlay Then RandomizeSprite(i)
         End Select

      End If

      'deactivate phasers if out of Client Rectange
      If (Sprites(i).type = %Phaser) And (PtInRect(ClientR,Sprites(i).pt)=0) Then Sprites(i).active = 0

   Next i

   'draw remaining ships
   If ShowShips Then
      Local tempSprite As SpriteType
      tempSprite = Sprites(0)
      Sprites(0).y = 10 : Sprites(0).theta = 3.1416\2
      Sprites(0).hBMP = Images(0).hBMP : Sprites(0).hDC = Images(0).hDC
      For i = 1 To ShipCount-1
         Sprites(0).x = i * 30
         ShowSprite 0
      Next i
      Sprites(0) = tempSprite
   End If

   Graphic ReDraw
End Sub

Sub ShowSprite(idx As Long)
   Local theta As Single, x,y,XCenter, YCenter As Long
   Dim PlgPts(0 To 2) As PointAPI
   theta = Sprites(idx).theta
   XCenter = Sprites(idx).w\2 : YCenter = Sprites(idx).h\2

   x = 0 : y = 0
   PlgPts(0).X = XCenter + (x - XCenter) * Cos(theta) - (y - YCenter) * Sin(theta)  'upper-left in target
   PlgPts(0).Y = YCenter + (x - XCenter) * Sin(theta) + (y - YCenter) * Cos(theta)

   x = Sprites(idx).w : y = 0
   PlgPts(1).X = XCenter + (x - XCenter) * Cos(theta) - (y - YCenter) * Sin(theta)  'upper-right in target
   PlgPts(1).Y = YCenter + (x - XCenter) * Sin(theta) + (y - YCenter) * Cos(theta)

   x = 0 : y = Sprites(idx).h
   PlgPts(2).X = XCenter + (x - XCenter) * Cos(theta) - (y - YCenter) * Sin(theta)  'lower left in target
   PlgPts(2).Y = YCenter + (x - XCenter) * Sin(theta) + (y - YCenter) * Cos(theta)

   Graphic Attach hBMPR, 0
   Graphic Clear
   Graphic Attach hDlg, %IDC_Graphic, ReDraw

   PlgBlt(hDCR, PlgPts(0), Sprites(idx).hDC, 0, 0, Sprites(idx).w, Sprites(idx).h, 0&, 0, 0)  ' Draw rotated image
   TransparentBlt hDC,Sprites(idx).x,Sprites(idx).y,70,70,hDCR,0,0,70,70,%Black

End Sub

Sub FirePhaser
   Incr MaxPhaser : If MaxPhaser > 200 Then MaxPhaser = 21   '21-200 is allow range
   'set phaser properties
   Sprites(MaxPhaser).hBMP   = Images(3).hBMP
   Sprites(MaxPhaser).hDC    = Images(3).hDC
   Sprites(MaxPhaser).w      = Images(3).w
   Sprites(MaxPhaser).h      = Images(3).h
   Sprites(MaxPhaser).x      = Sprites(0).x + Images(3).w\2
   Sprites(MaxPhaser).y      = Sprites(0).y + Images(3).h\2
   Sprites(MaxPhaser).theta  = Sprites(0).theta
   Sprites(MaxPhaser).type   = %Phaser
   Sprites(MaxPhaser).Active = 1

   'get components, in direction of theta, of velocity change to be applied
   Sprites(MaxPhaser).velX   = -10 * Sin(Sprites(MaxPhaser).theta)
   Sprites(MaxPhaser).velY   = 10 * Cos(Sprites(MaxPhaser).theta)

   Sprites(MaxPhaser).x += Sprites(MaxPhaser).velX/10*20
   Sprites(MaxPhaser).y += Sprites(MaxPhaser).velY/10*20
End Sub


Sub Settings_INI(Task$)
   Local x,y As Long
   Local xResult, yResult, temp, INIFileName As WStringZ*%Max_Path
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "100", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "100", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "650", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "650", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult), Val(yResult)   'width/height

      'get value for string variables
'      Getprivateprofilestring "All", "FontName", "Courier New", FontName, %Max_Path, INIFileName
      'get value for numeric variables
      Getprivateprofilestring "All", "gM", "150", temp, %Max_Path, INIFileName:  gM = Val(temp)
      Getprivateprofilestring "All", "Background", "6", temp, %Max_Path, INIFileName:  Background = Val(temp)
      Getprivateprofilestring "All", "Mute", "0", temp, %Max_Path, INIFileName:  Mute = Val(temp)
      Getprivateprofilestring "All", "Volume", "50", temp, %Max_Path, INIFileName:  Volume = Val(temp)
      Getprivateprofilestring "All", "MaxPhaser", "21", temp, %Max_Path, INIFileName:  MaxPhaser = Val(temp)
      Getprivateprofilestring "All", "ShipCount", "5", temp, %Max_Path, INIFileName:  ShipCount = Val(temp)
      Getprivateprofilestring "All", "AsteroidCount", "10", temp, %Max_Path, INIFileName:  AsteroidCount = Val(temp)
      Getprivateprofilestring "All", "ContinuousPlay", "1", temp, %Max_Path, INIFileName:  ContinuousPlay = Val(temp)
      Getprivateprofilestring "All", "ScrollBackground", "1", temp, %Max_Path, INIFileName:  ScrollBackground = Val(temp)
      Getprivateprofilestring "All", "ShowShips", "1", temp, %Max_Path, INIFileName:  ShowShips = Val(temp)
      Getprivateprofilestring "All", "SaveSession", "1", temp, %Max_Path, INIFileName:  SaveSession = Val(temp)
      Getprivateprofilestring "All", "PlayGame", "1", temp, %Max_Path, INIFileName:  PlayGame = Val(temp)
      Getprivateprofilestring "All", "GameLevel", "1", temp, %Max_Path, INIFileName:  GameLevel = Val(temp)
      Getprivateprofilestring "All", "GameScore", "0", temp, %Max_Path, INIFileName:  GameScore = Val(temp)
      Getprivateprofilestring "All", "MaxGameScore", "0", temp, %Max_Path, INIFileName:  MaxGameScore = Val(temp)
      Getprivateprofilestring "All", "AutoRun", "1", temp, %Max_Path, INIFileName:  AutoRun = Val(temp)
      Getprivateprofilestring "All", "Interval", "50", temp, %Max_Path, INIFileName:  Interval = Val(temp)
   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
'      WritePrivateProfileString "All", "FontName",FontName, INIFileName
      'save numeric variables
      WritePrivateProfileString "All", "gM", Str$(gM), INIFileName
      WritePrivateProfileString "All", "Background", Str$(Background), INIFileName
      WritePrivateProfileString "All", "Mute", Str$(Mute), INIFileName
      WritePrivateProfileString "All", "Volume", Str$(Volume), INIFileName
      WritePrivateProfileString "All", "MaxPhaser", Str$(MaxPhaser), INIFileName
     'WritePrivateProfileString "All", "ShipCount", Str$(ShipCount), INIFileName
     'WritePrivateProfileString "All", "AsteroidCount", Str$(AsteroidCount), INIFileName
      WritePrivateProfileString "All", "ContinuousPlay", Str$(ContinuousPlay), INIFileName
      WritePrivateProfileString "All", "ScrollBackground", Str$(ScrollBackground), INIFileName
      WritePrivateProfileString "All", "ShowShips", Str$(ShowShips), INIFileName
      WritePrivateProfileString "All", "SaveSession", Str$(SaveSession), INIFileName
      WritePrivateProfileString "All", "PlayGame", Str$(PlayGame), INIFileName
      WritePrivateProfileString "All", "GameLevel", Str$(GameLevel), INIFileName
      WritePrivateProfileString "All", "GameScore", Str$(GameScore), INIFileName
      WritePrivateProfileString "All", "MaxGameScore", Str$(MaxGameScore), INIFileName
      WritePrivateProfileString "All", "AutoRun", Str$(AutoRun), INIFileName
      WritePrivateProfileString "All", "Interval", Str$(Interval), INIFileName
   End If
End Sub

Sub CreateStatusBar
   Control Add Statusbar, hDlg, %IDC_StatusBar,"",0,0,0,0, %SBars_SizeGrip, %WS_Ex_ClientEdge
   Statusbar Set Parts hDlg, %IDC_StatusBar, 100,250,100, 99999
End Sub

Sub CreateToolbar
    Local hImageList As Dword
    ImageList New Icon 24,24,24,50 To hImageListTB
    ImageList Add Icon hImageListTB, "xnew"       '1
    ImageList Add Icon hImageListTB, "xsettings"  '2
    ImageList Add Icon hImageListTB, "xhelp"      '3
    ImageList Add Icon hImageListTB, "xsoundb"    '4
    ImageList Add Icon hImageListTB, "xexit"      '5
    ImageList Add Icon hImageListTB, "xcenter"    '6
    ImageList Add Icon hImageListTB, "xpause"     '7
    ImageList Add Icon hImageListTB, "xplay"      '8

    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0,%TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS

    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageListTB, 0

    Toolbar Add Button    hDlg, %IDC_Toolbar, 8,  %IDT_Play, %BTNS_CheckGroup, "Play"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 7,  %IDT_Pause, %BTNS_CheckGroup, "Pause"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 1,  %IDT_New, %BTNS_Button, "New"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 20
    Toolbar Add Button    hDlg, %IDC_Toolbar, 6,  %IDT_Center, %BTNS_Button, "Center"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 4,  %IDT_Mute, %BTNS_Check, "Mute"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 2,  %IDT_Settings,  %BTNS_Button Or %BTNS_DropDown, "Settings"
    Toolbar Add Button    hDlg, %IDC_Toolbar, 3,  %IDT_Help,  %BTNS_Button Or %BTNS_DropDown, "Help"

    Menu New PopUp To hSettings
    Menu Add String, hSettings, "Change Background", %IDM_Background, %MF_Enabled
    Menu Add String, hSettings, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hSettings, "AutoRun On Start", %IDM_AutoRun, %MF_Enabled
    Menu Add String, hSettings, "Continuous Play", %IDM_Continuous, %MF_Enabled
    Menu Add String, hSettings, "Scroll Background", %IDM_ScrollBackground, %MF_Enabled
    Menu Add String, hSettings, "Display Reserve Ships", %IDM_ShowShips, %MF_Enabled
    Menu Add String, hSettings, "Save Session on Close", %IDM_SaveSession, %MF_Enabled
    Menu Add String, hSettings, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hSettings, "Level 1: 10 Slower Asteroids", %IDM_Level1, %MF_Enabled
    Menu Add String, hSettings, "Level 2: 25 Slower Asteroids", %IDM_Level2, %MF_Enabled
    Menu Add String, hSettings, "Level 3: 25 Faster Asteroids", %IDM_Level3, %MF_Enabled

    Menu New PopUp To hHelp
    Menu Add String, hHelp, "Online Update", %IDM_OnlineUpdate, %MF_Enabled
End Sub

Function SetToolTips(cID As Long) As String
   Select Case cID         'or this:   @P.hdr.idFrom
      Case %IDT_Play        : Function = "Play Game"
      Case %IDT_Pause       : Function = "Pause Game"
      Case %IDT_New         : Function = "New Game"
      Case %IDT_Center      : Function = "Center Ship and Set Speed to Zero"
      Case %IDT_Mute        : Function = "Mute Game Sounds"
      Case %IDT_Settings    : Function = "Settings"
      Case %IDT_Help        : Function = "Online Help"
   End Select
End Function

Sub SetShipMode
   If Blast Then
      Sprites(0).hBMP  = Images(1).hBMP
      Sprites(0).hDC  = Images(1).hDC
   Else
      Sprites(0).hBMP  = Images(0).hBMP
      Sprites(0).hDC  = Images(0).hDC
   End If
End Sub

Sub SetMenusAndToolbar
   'Toolbar Buttons
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Mute, Mute * %TBState_Checked Or %TBState_Enabled
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Play, IIf(PlayGame,1,0) * %TBState_Checked Or %TBState_Enabled
    Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Pause, IIf(PlayGame,0,1) * %TBState_Checked Or %TBState_Enabled
   'Menus
   Menu Set State hSettings, ByCmd %IDM_Continuous, ContinuousPlay * %MFS_Checked Or %MFS_Enabled
   Menu Set State hSettings, ByCmd %IDM_ScrollBackground, ScrollBackground * %MFS_Checked Or %MFS_Enabled
   Menu Set State hSettings, ByCmd %IDM_ShowShips, ShowShips * %MFS_Checked Or %MFS_Enabled
   Menu Set State hSettings, ByCmd %IDM_SaveSession, SaveSession * %MFS_Checked Or %MFS_Enabled
   Menu Set State hSettings, ByCmd %IDM_AutoRun, AutoRun * %MFS_Checked Or %MFS_Enabled
   Menu Set State hSettings, ByCmd %IDM_Level1, IIf(GameLevel=1,1,0) * %MFS_Checked Or %MFS_Enabled
   Menu Set State hSettings, ByCmd %IDM_Level2, IIf(GameLevel=2,1,0) * %MFS_Checked Or %MFS_Enabled
   Menu Set State hSettings, ByCmd %IDM_Level3, IIf(GameLevel=3,1,0) * %MFS_Checked Or %MFS_Enabled
End Sub

Sub BuildAcceleratorTable
   Local cc As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(2)
   ac(cc).fvirt = %FVIRTKEY  : ac(cc).key   = %VK_F1          : ac(cc).cmd  = %IDT_Help     : Incr cc
   ac(cc).fvirt = %FVIRTKEY  : ac(cc).key   = %VK_Escape      : ac(cc).cmd  = %IDM_Escape   : Incr cc
   ac(cc).fvirt = %FVIRTKEY Or %FCONTROL : ac(cc).key = %VK_C : ac(cc).cmd  = %IDT_Center   : Incr cc

   Accel Attach hDlg, AC() To hAccelerator
End Sub

Function NewProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Select Case Msg
      Case %WM_LButtonDown   : If PlayGame Then Fire = 1  : FirePhaser : PlayWave "xphaser",""
'         If PlayGame And (Fire=0) Then Fire = 1 : SetTimer hDlg, %ID_TimerPhaser, 200, 0
      Case %WM_LButtonDblClk : If PlayGame Then Fire = 1  : FirePhaser : PlayWave "xphaser",""
'         If PlayGame And (Fire=0) Then Fire = 1 : SetTimer hDlg, %ID_TimerPhaser, 200, 0
      Case %WM_RButtonDown   : If PlayGame Then Blast = 1 : SetShipMode : CalculateVelocityVectors : PlayWave "xrocket","loop"
      Case %WM_KeyDown
         Select Case wParam
            Case %VK_Space   : If PlayGame Then Fire = 1  : FirePhaser : PlayWave "xphaser", "loop"
'               If PlayGame And (Fire=0) Then Fire = 1 : SetTimer hDlg, %ID_TimerPhaser, 200, 0

            Case %VK_Up      : If PlayGame Then Blast = 1 : SetShipMode : CalculateVelocityVectors : PlayWave "xrocket", "loop"
            Case %VK_Down    : If PlayGame Then Sprites(0).theta += 3.1416 : Blast = 1 : SetShipMode : CalculateVelocityVectors : PlayWave "xrocket","loop"
            Case %VK_Left    : If PLayGame Then Sprites(0).theta -= 0.2
            Case %VK_Right   : If PLayGame Then Sprites(0).theta += 0.2
         End Select

      Case %WM_LButtonUp     : If PlayGame Then Fire = 0  : Play Wave End
'         If PlayGame Then Fire = 0 : KillTimer hDlg, %ID_TimerPhaser : Play Wave End
      Case %WM_RButtonUp     : If PlayGame Then Blast = 0 : Play Wave End : SetShipMode
      Case %WM_KeyUp
         Select Case wParam
            Case %VK_Space   ': If PlayGame Then Fire = 0  : Play Wave End
               If PlayGame Then Fire = 0 : KillTimer hDlg, %ID_TimerPhaser : Play Wave End

            Case %VK_Up      : If PlayGame Then Blast = 0 : Play Wave End : SetShipMode
            Case %VK_Down    : If PlayGame Then Blast = 0 : Play Wave End : SetShipMode
         End Select

      Case %WM_MouseWheel
         Select Case Hi(Integer,wParam)    'note the use of Integer
            Case > 0 : If PlayGame Then Sprites(0).theta -= 0.2
            Case < 0 : If PlayGame Then Sprites(0).theta += 0.2
         End Select
   End Select
   Function = CallWindowProc(OldProc&, hWnd, Msg, wParam, lParam)
End Function

Sub CalculateVelocityVectors
   'get components, in direction of theta, of velocity change to be applied
   BlastX = 2 * Sin(Sprites(0).theta)
   BlastY = 2 * Cos(Sprites(0).theta)
End Sub

Sub CenterShip
   Local w,h As Long
   Control Get Client hDlg, %IDC_Graphic To w,h
   Sprites(0).theta  = 3.14159
   Sprites(0).velx   = 0
   Sprites(0).vely   = 0
   Sprites(0).x      = (w-Images(0).w)\2
   Sprites(0).y      = (h-Images(0).h)\2
   Sprites(0).active = 1
End Sub

Sub DetectCollisions
   Local i,j As Long, r As rect
   For i = 0 To 200
      If Sprites(i).active < 1 Then Iterate For  'ignore inactive sprites
      If PtInRect(ClientR, Sprites(i).pt) = 0 Then Iterate For  'ship must be visible to be killed
      For j = 0 To 200
         'ignore invalid events
         If (j = i) Or (Sprites(j).active < 1) Then Iterate For  'ignore inactive sprites
         If (Sprites(i).type = %Phaser) And (Sprites(j).type = %Phaser) Then Iterate For   'phasers cannot collide

         'collision detection
         IntersectRect r, Sprites(i).r, Sprites(j).r
         If IsRectEmpty(r) Then Iterate For

        'react to collision
         If (Sprites(i).type = %Phaser) And (Sprites(j).type = %Asteroid) Then  'PHASER-ASTEROID COLLISION
            PlayWave "xexplode",""
            'phaser goes away
            Sprites(i).active = 0
            'asteroid looks dead
            GameScore += 1 : FillStatusBar
            Sprites(j).hBMP = Images(4).hBMP
            Sprites(j).hDC = Images(4).hDC
            Sprites(j).active = -4

         ElseIf (Sprites(i).type = %Ship) And (Sprites(j).type = %Asteroid) Then 'SHIP-ASTEROID COLLISON
            PlayWave "xexplode",""

            'asteriod goes away
            GameScore += 1
            Sprites(j).hBMP = Images(4).hBMP
            Sprites(j).hDC = Images(4).hDC
            Sprites(j).active = -4

            'ship goes away
            Sprites(i).hBMP   = Images(11).hBMP
            Sprites(i).hDC    = Images(11).hDC
            Sprites(i).w      = Images(11).w
            Sprites(i).h      = Images(11).h
            Sprites(i).active = -4

         ElseIf (Sprites(i).type = %Asteroid) And (Sprites(j).type = %Asteroid) Then 'ASTEROID-ASTEROID COLLISION
            'asteroids collisions ignored. code shown FYI
            ''both asteroids go away
            'GameScore += 1 : GamesScore += 1 : FillStatusBar
            'PlayWave "xexplode",""
            'Sprites(i).hBMP = Images(4).hBMP : Sprites(i).hDC = Images(4).hDC : Sprites(i).active = -4
            'Sprites(j).hBMP = Images(4).hBMP : Sprites(j).hDC = Images(4).hDC : Sprites(j).active = -4
         End If
      Next j
   Next i
End Sub

Sub FillStatusBar
   Statusbar Set Text hDlg, %IDC_StatusBar, 1, 0, "  Ships: " + Str$(ShipCount)
   Statusbar Set Text hDlg, %IDC_StatusBar, 2, 0, "  Asteroids Destroyed: " + Str$(GameScore)
   Statusbar Set Text hDlg, %IDC_StatusBar, 3, 0, "  FPS: " + Str$(FPS)
   Statusbar Set Text hDlg, %IDC_StatusBar, 4, 0, "  Level:" + Str$(GameLevel) + IIf$(ContinuousPlay,"   Continuous Play","   Game Play")

End Sub

Sub CreateFonts
   Font New "Tahoma",10,0 To hFont
   Control Set Font hDlg, %IDC_Toolbar, hFont
   Control Set Font hDlg, %IDC_StatusBar, hFont
End Sub

Sub PlayWave(task$, prop$)
   If Mute Then Exit Sub
   If Len(prop$) Then
      Play Wave task$, Loop
   Else
      Play Wave task$
   End If
End Sub

Sub DisplayHelp
   Local temp$, i As Long
   Graphic Font "Tahoma", 14, 0
   Graphic Color %Red, -2
   Graphic Set Pos (50,20) :  Graphic Print "Destroy the asteroids with phaser blasts"
   Graphic Set Pos (50,40) :  Graphic Print "before they crash into your ships.
   Graphic Set Pos (50,90) :  Graphic Print "Mouse:"
   Graphic Set Pos (50,110) :  Graphic Print "Wheel Forward - Rotate ship counter-clockwise"
   Graphic Set Pos (50,130) : Graphic Print "Wheel Reverse - Rotate ship clockwise"
   Graphic Set Pos (50,150) : Graphic Print "Left Mouse Button - Fire phaser. 1 per click"
   Graphic Set Pos (50,170) : Graphic Print "Right Mouse Button - Turn on rocket engine"
   Graphic Set Pos (50,190) : Graphic Print "   - Thrust is in direction of ship nose"
   Graphic Set Pos (50,210) : Graphic Print "   - Hold mouse down for continuous thrust"
   Graphic Set Pos (50,260) : Graphic Print "Keyboard:"
   Graphic Set Pos (50,280) : Graphic Print "Left Arrow - Rotate ship counter-clockwise"
   Graphic Set Pos (50,300) : Graphic Print "Right Arrow - Rotate ship clockwise"
   Graphic Set Pos (50,320) : Graphic Print "Space Bar - Fire phaser"
   Graphic Set Pos (50,340) : Graphic Print "   - 1 Per Click"
   Graphic Set Pos (50,360) : Graphic Print "   - Hold for continuous phase fire"
   Graphic Set Pos (50,380) : Graphic Print "Up Arrow - Turn on rocket engine"
   Graphic Set Pos (50,400) : Graphic Print "   - Thrust is in direction of ship nose"
   Graphic Set Pos (50,420) : Graphic Print "   - Hold key for continuous thrust"
   Graphic Set Pos (50,440) : Graphic Print "Down Arrow - Turn ship 180 degrees"
   Graphic Set Pos (50,460) : Graphic Print "   - Single burst of thrust"
   Graphic Set Pos (50,480) : Graphic Print "Ctrl-C - Same as Center Button"
   Graphic Set Pos (50,500) : Graphic Print "ESC    - Same as Pause Button"

   Graphic Font "Tahoma", 36, 0
   Graphic ReDraw
   Graphic Color %Black, %Black
End Sub

Sub EndGame
   Local w,h, tw,th As Long, temp$
   temp$ = "Game Over!"
   Graphic Color %Red, -2
   Graphic Get Canvas To w,h
   Graphic Set Pos ((w-Graphic(Text.Size.X,temp$))/2, (h-Graphic(Text.Size.Y,temp$))/2)
   Graphic Print temp$
   Graphic ReDraw
   Graphic Color %Black, %Black
End Sub

Sub ScrollBackgroundImage(ddx As Long, ddy As Long)
   Local i,j,canvasW,canvasH,imgCountX,imgCountY,x0,y0,xNew,yNew,imgW,imgH As Long
   Static imgX,imgY As Long
   imgW = Images(Background).w
   imgH = IMages(Background).h
   'grid size
   Graphic Get Canvas To CanvasW, CanvasH
   imgCountX = CanvasW\imgW + 2      : imgCountY = CanvasH\imgH + 2        'grid size
   'starting position of image grid (xNew,yNew)
   x0 = imgX Mod imgW                : y0 = imgY Mod imgH                  'x0,y0 is position within image
   x0 = IIf(imgX > 0, 0, -imgW) - x0 : y0 = IIf(imgY > 0, 0, -imgH) - y0   'x0,y0 is position within image
   'create grid of images
   xNew = x0 : yNew = y0     '(xNew,yNew) is position of each new grid element to display
   For j = 1 To imgCountY     'column of images
      For i = 1 To imgCountX  'row of images
         Graphic Copy Images(Background).hBMP, 0, (0,0)-(imgW-1,imgH-1) To (xNew,yNew) 'copy whole image to xNew,yNew
         xNew += imgW
      Next i
      xNew = x0 : yNew += imgH
   Next j
   'scroll for next frame
   If ScrollBackGround Then imgX += ddx : imgY += ddy
End Sub

Sub SaveGameSession
   Open $SessionFile For Binary As #1
   Put #1,, Sprites()
   Close #1
End Sub

Sub LoadGameSession
   Local i As Long
   'load file into array
   Open $SessionFile For Binary As #1
   Get #1,, Sprites()
   Close #1

   'refresh handles/device contexts
   Sprites(0).hBMP   = Images(0).hBMP
   Sprites(0).hDC    = Images(0).hDC
   For i = 1 To AsteroidCount
      Sprites(i).hBMP = Images(2).hBMP
      Sprites(i).hDC = Images(2).hDC
   Next i
End Sub

Sub CreateSubFolders
   If IsFolder (Exe.Path$ + "files") = %False Then MkDir Exe.Path$ + "files"
   If IsFolder (Exe.Path$ + "images") = %False Then MkDir Exe.Path$ + "images"
   If IsFolder (Exe.Path$ + "tempfiles") = %False Then MkDir Exe.Path$ + "tempfiles"
End Sub
